import { readFileSync } from 'fs';

import { convert } from '../src';

describe('Test from ACD Jcamp generator', () => {
  it('COSY simulated spectrum', () => {
    let result = convert(
      readFileSync(`${__dirname}/data/acd/test1_cosy.jdx`).toString(),
    );
    expect(result.entries[0].ntuples).toHaveLength(3);
    expect(result.entries[0].twoD).toBe(true);
    expect(result.entries[0].contourLines).toBeInstanceOf(Object);
  });
  it('assignment', () => {
    let result = convert(readFileSync(`${__dirname}/data/acd/assignment.jdx`), {
      keepRecordsRegExp: /.*/,
    });
    expect(result.flatten).toHaveLength(5);
    const meta = result.flatten[1].info;
    expect(Object.keys(meta)).toHaveLength(9);
  });
  it('just assignment', () => {
    let result = convert(
      readFileSync(`${__dirname}/data/acd/justAssignment.jdx`),
      {
        keepRecordsRegExp: /.*/,
      },
    );
    const assignment = result.flatten[0].spectra[0].data;
    expect(assignment.x).toHaveLength(12);
    expect(assignment.y).toHaveLength(12);
    expect(assignment.m).toHaveLength(12);
    expect(assignment.a).toHaveLength(12);
    expect(assignment).toMatchSnapshot();
  });
});
