import { readFileSync } from 'fs';

import { convert } from '../src';

let jcamp = readFileSync(
  `${__dirname}/data/semtech100indicator.jdx`,
).toString();

describe('Test conversion option for jcamp', () => {
  it('1H NMR ethyl vinyl ether', () => {
    let result = convert(jcamp);

    let x = result.entries[0].spectra[0].data.x;
    let y = result.entries[0].spectra[0].data.y;

    // Check X and Y length
    expect(x).toHaveLength(951);
    expect(y).toHaveLength(951);

    expect(x[0]).toBe(400);
    expect(x[100]).toBe(600);
    expect(y[0]).toBe(2861);
    expect(y[100]).toBe(1367);
  });
});
