import { readFileSync } from 'fs';

import { xyMaxYPoint } from 'ml-spectra-processing';

import { convert } from '../src';

describe('jeol', () => {
  it('first test', () => {
    let result = convert(
      readFileSync(`${__dirname}/data/jeol/jeol.dx`, 'utf8'),
    );
    let spectrum = result.flatten[0].spectra[0];

    expect(spectrum.firstX).toBeCloseTo(15.1029, 3);
    expect(spectrum.lastX).toBeCloseTo(-4.88666, 4);
    expect(spectrum.deltaX).toBeCloseTo(-0.0012201, 4);
  });
  it('aspirin', () => {
    let result = convert(
      readFileSync(`${__dirname}/data/jeol/jeol.dx`, 'utf8'),
    );
    let spectrum = result.flatten[0].spectra[0];
    let point = xyMaxYPoint(spectrum.data);
    expect(point).toStrictEqual({
      x: 2.612321845763589,
      y: 55.4017094664,
      index: 10237,
    });
  });
});
